// R3DCuboid.h: interface for the R3DCuboid class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_R3DCUBOID_H__0C70BEA1_F3E9_11D1_A61E_444553540000__INCLUDED_)
#define AFX_R3DCUBOID_H__0C70BEA1_F3E9_11D1_A61E_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "R3DShape.h"
#include "R3DVertex.h"	// Added by ClassView
#include "R3DVector.h"	// Added by ClassView
#include "R3DTexture.h"	// Added by ClassView
#include "R3DRectangle.h"	// Added by ClassView

class R3DCuboid : public R3DShape, CObject
{
public:
	R3DCuboid& operator=(const R3DCuboid &c);
	 R3DCuboid(const R3DCuboid &c);
	void Serialize(CArchive & archive);
	DECLARE_SERIAL( R3DCuboid )
	void Move(R3DVector v);
	void SetTexture(R3DTexture t);
	void RotateZ(R3DVector Origin, float Theta);
	void RotateY(R3DVector Origin, float Theta);
	void RotateX(R3DVector Origin, float Theta);
	void SetPosition(R3DVector v1, R3DVector v2);
	void Draw();
	R3DCuboid();
	virtual ~R3DCuboid();

protected:
	void SetupFaces();
	R3DRectangle mFaces[6];
	R3DVector mCorners[8];
	R3DVector mOrigin;
	R3DTexture mTexture;
};

#endif // !defined(AFX_R3DCUBOID_H__0C70BEA1_F3E9_11D1_A61E_444553540000__INCLUDED_)
