// R3DCylinder.h: interface for the R3DCylinder class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_R3DCYLINDER_H__13FBB081_F547_11D1_A61E_444553540000__INCLUDED_)
#define AFX_R3DCYLINDER_H__13FBB081_F547_11D1_A61E_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "R3DShape.h"
#include "R3DTexture.h"	// Added by ClassView
#include "R3DVector.h"	// Added by ClassView
#include "R3DTriangle.h"	// Added by ClassView
#include "R3DRectangle.h"	// Added by ClassView

class R3DCylinder : public R3DShape, CObject  
{
public:
	void Spin(float distance);
	R3DCylinder& operator=(const R3DCylinder& c);
	R3DCylinder(const R3DCylinder &c);
	void Serialize(CArchive & archive);
	DECLARE_SERIAL( R3DCylinder )
	void SetupTexture(float facescale, float edgescale);
	void SetTexture(R3DTexture t);
	void Draw();
	void RotateZ(R3DVector Origin, float Theta);
	void RotateY(R3DVector Origin, float Theta);
	void RotateX(R3DVector Origin, float Theta);
	void Move(R3DVector v);
	void SetTexture(R3DTexture face, R3DTexture edge);
	void SetPosition(R3DVector centre, float depth, float radius);
	R3DCylinder();
	virtual ~R3DCylinder();

protected:
	float mCircumference;
	R3DVector mCentre;
	R3DVector mRotation;
	float mRadius;
	float mFaceTexScale;
	float mEdgeTexScale;
	void SetupFaces();
	R3DRectangle mRectangles[10];
	R3DTexture mEdgeTexture;
	R3DTriangle mTriangles[20];
	R3DTexture mFaceTexture;
	R3DVector mCorners[22];
};

#endif // !defined(AFX_R3DCYLINDER_H__13FBB081_F547_11D1_A61E_444553540000__INCLUDED_)
