// R3DGroup.cpp: implementation of the R3DGroup class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
//#include "Traffic3D.h"
#include "R3DGroup.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

R3DGroup::R3DGroup()
{

}

R3DGroup::~R3DGroup()
{

}

// draws all the objects in the list in turn:
void R3DGroup::Draw()
{
	POSITION pos=this->GetHeadPosition();
	while(pos!=NULL)
		{
		this->GetNext(pos)->Draw();
		}
}

// moves all the objects in the list in turn
void R3DGroup::Move(R3DVector v)
{
	POSITION pos=this->GetHeadPosition();
	while(pos!=NULL)
		{
		this->GetNext(pos)->Move(v);
		}
}

// Rotate each element in the list in turn:
void R3DGroup::RotateX(R3DVector Origin, float Theta)
{
	POSITION pos=this->GetHeadPosition();
	while(pos!=NULL)
		{
		this->GetNext(pos)->RotateX(Origin, Theta);
		}
}

void R3DGroup::RotateY(R3DVector Origin, float Theta)
{
	POSITION pos=this->GetHeadPosition();
	while(pos!=NULL)
		{
		this->GetNext(pos)->RotateY(Origin, Theta);
		}
}

void R3DGroup::RotateZ(R3DVector Origin, float Theta)
{
	POSITION pos=this->GetHeadPosition();
	while(pos!=NULL)
		{
		this->GetNext(pos)->RotateZ(Origin, Theta);
		}
}

// set all the shapes to have the same texture:
void R3DGroup::SetTexture(R3DTexture t)
{
	POSITION pos=this->GetHeadPosition();
	while(pos!=NULL)
		{
		this->GetNext(pos)->SetTexture(t);
		}
}
