// R3DRectangle.h: interface for the R3DRectangle class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_R3DRECTANGLE_H__2C706DE1_F4A2_11D1_A61E_444553540000__INCLUDED_)
#define AFX_R3DRECTANGLE_H__2C706DE1_F4A2_11D1_A61E_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "R3DShape.h"
#include "R3DVector.h"	// Added by ClassView
#include "R3DTriangle.h"	// Added by ClassView
#include "R3DTexture.h"	// Added by ClassView

class R3DRectangle : public R3DShape, CObject  
{
public:
	R3DRectangle& operator=(const R3DRectangle &r);
	R3DRectangle(const R3DRectangle &r);
	void Serialize(CArchive & archive);
	DECLARE_SERIAL( R3DRectangle )
	void SetTexture(R3DTexture t, float right, float bottom);
	void SetupTexture(float offset_s, float offset_t, float scale=0);
	void Draw(void);
	void SetTexture(R3DTexture t);
	void Move(R3DVector v);
	void RotateZ(R3DVector Origin, float Theta);
	void RotateY(R3DVector Origin, float Theta);
	void RotateX(R3DVector Origin, float Theta);
	void SetPosition(const R3DVector& v1, const R3DVector& v2, const R3DVector& v3, const R3DVector& v4);
	void SetPosition(const R3DVector& v1, const R3DVector& v2);
	R3DRectangle();
	virtual ~R3DRectangle();

protected:
	float mTexOffset_t;
	float mTexOffset_s;
	float mTexScale;
	R3DVertex mCorners[4];
	R3DTexture mTexture;
};

#endif // !defined(AFX_R3DRECTANGLE_H__2C706DE1_F4A2_11D1_A61E_444553540000__INCLUDED_)
