// R3DShape.h: interface for the R3DShape class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_R3DSHAPE_H__91D530C0_D211_11D1_A61E_444553540000__INCLUDED_)
#define AFX_R3DSHAPE_H__91D530C0_D211_11D1_A61E_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "R3DVertex.h"	// Added by ClassView
#include "R3DVector.h"	// Added by ClassView
#include "R3DTexture.h"	// Added by ClassView

// R3DShape is a purely abstract class from which all other screen drawable R3D
// classes are derived.
// R3DShapes are texture mapped and coloured and can be scaled, rotated and moved.

class R3DShape  
{
public:
	//R3DShape()=0;
	//virtual ~R3DShape()=0;

	virtual void RotateX(R3DVector origin, float theta)=0;
	virtual void RotateY(R3DVector origin, float theta)=0;
	virtual void RotateZ(R3DVector origin, float theta)=0;	// rotate about a given origin
	virtual void Move(R3DVector v)=0;		// move relative
	//virtual void MoveTo(R3DVector v)=0;		// move absolute
	virtual void SetTexture(R3DTexture t)=0;

	virtual void Draw()=0;	// actually draws the shape!
};

#endif // !defined(AFX_R3DSHAPE_H__91D530C0_D211_11D1_A61E_444553540000__INCLUDED_)
