// R3DTriangle.h: interface for the R3DTriangle class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_R3DTRIANGLE_H__5027CDA1_E818_11D1_9F88_0000E822356F__INCLUDED_)
#define AFX_R3DTRIANGLE_H__5027CDA1_E818_11D1_9F88_0000E822356F__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "R3DShape.h"
#include "R3DVertex.h"	// Added by ClassView
#include "R3DVector.h"	// Added by ClassView
#include "R3DTexture.h"	// Added by ClassView

class R3DTriangle : public R3DShape, CObject
{
public:
	R3DTriangle& operator=(const R3DTriangle &t);
	 R3DTriangle(const R3DTriangle &t);
	void Serialize(CArchive &archive);
	DECLARE_SERIAL( R3DTriangle )
	void SetupTexture(float offset_s, float offset_t, float scale);
	void Move(R3DVector v);
	void RotateZ(R3DVector Origin, float Theta);
	void RotateY(R3DVector Origin, float Theta);
	void RotateX(R3DVector Origin, float Theta);
	 R3DTriangle(R3DVector v1, R3DVector v2, R3DVector v3);
	void SetPosition(R3DVector v1, R3DVector v2, R3DVector v3);
	virtual void SetTexture(R3DTexture t);
	virtual void Draw();
	R3DTriangle();
	virtual ~R3DTriangle();

protected:
	float mTexScale;
	float mTexOffset_t;
	float mTexOffset_s;
	R3DTexture mTexture;
	R3DVector mOrigin;
	R3DVertex mVertexes[3];
};

#endif // !defined(AFX_R3DTRIANGLE_H__5027CDA1_E818_11D1_9F88_0000E822356F__INCLUDED_)
