// R3DVector.h: interface for the R3DVector class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_R3DVECTOR_H__257BB456_C720_11D1_9F87_0000E822356F__INCLUDED_)
#define AFX_R3DVECTOR_H__257BB456_C720_11D1_9F87_0000E822356F__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class R3DVector : public CObject  
{
public:
	void Serialize(CArchive & archive);
	DECLARE_SERIAL( R3DVector )
	R3DVector(const R3DVector &v)
		{m_vx=v.m_vx; m_vy=v.m_vy; m_vz=v.m_vz;}	// copy constructor
	R3DVector& operator=(const R3DVector& v)
		{m_vx=v.m_vx; m_vy=v.m_vy; m_vz=v.m_vz; return *this;}
	void RotateZ(R3DVector Origin, float Theta);
	void RotateY(R3DVector Origin, float Theta);
	void RotateX(R3DVector Origin, float Theta);
	void SetPosition(float x, float y, float z);
	float Length();
	void operator-= (R3DVector V);
	void operator+= (R3DVector V);
	 R3DVector(float x, float y, float z);
	float m_vz;
	float m_vy;
	float m_vx;
	R3DVector();
	virtual ~R3DVector();

};

// Global functions that operate on vectors.
// These are not members of R3DVector because they return new R3DVectors
float operator *(R3DVector A, R3DVector B);
R3DVector operator *(float A, R3DVector B);
R3DVector operator -(R3DVector A, R3DVector B);
R3DVector operator -(R3DVector A);
R3DVector operator +(R3DVector A, R3DVector B);
float operator ^(R3DVector A, R3DVector B);
R3DVector XProduct(R3DVector A, R3DVector B);

#endif // !defined(AFX_R3DVECTOR_H__257BB456_C720_11D1_9F87_0000E822356F__INCLUDED_)
