// R3DVertex.h: interface for the R3DVertex class.
//
//////////////////////////////////////////////////////////////////////

#include <glide.h>

#if !defined(AFX_R3DVERTEX_H__9901FAC1_D4E8_11D1_9F88_0000E822356F__INCLUDED_)
#define AFX_R3DVERTEX_H__9901FAC1_D4E8_11D1_9F88_0000E822356F__INCLUDED_

#include "R3DVector.h"	// Added by ClassView
#include "R3DCamera.h"
#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

// R3DVertex class embodies the vertex used by glide

class R3DVertex : public CObject
{
public:
	R3DVertex& operator=(const R3DVertex &v);
	void Serialize(CArchive & archive);
	DECLARE_SERIAL( R3DVertex )
	void SetTexPosition(float x, float y);
	void Move(R3DVector v);
	R3DVector GetPosition() {return mWorldOrigin;}
	void SetTexPosition(R3DVector v);
	void SetColour(R3DVector c);
	void SetPosition(R3DVector p);
	void SetPosition(float x, float y, float z);
	void RotateZ(R3DVector Origin, float Theta);
	void RotateY(R3DVector Origin, float Theta);
	void RotateX (R3DVector Origin, float Theta);
	R3DVertex(R3DVector v);
	R3DVertex();
	virtual ~R3DVertex();
	void Project();	// function to convert world co-ords to screen co-ords
	GrVertex* GetVertex() {return &mGVertex;}	// returns vertex as used by glide
	BOOL IsOnScreen() {return mOnScreen;}
	BOOL IsDrawable() {return mDrawable;}

protected:
	BOOL mOnScreen;
	BOOL mDrawable;
	BOOL mTransformed;
	float mt;
	float ms;	// texture co-ordinates
	R3DVector mWorldOrigin;	// world co-ords
	GrVertex mGVertex;	// vertex as used by glide functions
	R3DVector mScreenOrigin;	// screen co-ords
};

#endif // !defined(AFX_R3DVERTEX_H__9901FAC1_D4E8_11D1_9F88_0000E822356F__INCLUDED_)
