// R3DfxHardware.h: interface for the R3DfxHardware class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_R3DFXHARDWARE_H__1258C941_BC4C_11D1_9F87_0000E822356F__INCLUDED_)
#define AFX_R3DFXHARDWARE_H__1258C941_BC4C_11D1_9F87_0000E822356F__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
#include <glide.h>

class R3DfxHardware  
{
public:
	void SetTexture(GrMipMapId_t tex);
	void BufferClear();
	void BufferSwap();
	void ActivateTextures();
	GrMipMapId_t LoadTexture(char *filename);
	void CloseHardware();
	void SetDefaultOptions();
	int InitHardware();
	R3DfxHardware();
	virtual ~R3DfxHardware();
	BOOL IsInitialised() {return Initialised;}

protected:
	GrHwConfiguration hwconfig;
	BOOL Initialised;
private:
	GrMipMapId_t mCurrentTexture;
};

extern R3DfxHardware *R3DHW;	// a global pointer to the hardware device

#endif // !defined(AFX_R3DFXHARDWARE_H__1258C941_BC4C_11D1_9F87_0000E822356F__INCLUDED_)
